<template>
  <div class="container" v-on:click="stopSound">
      <h3 class=" text-center">Messaging</h3>
      <div class="messaging">
          <div class="inbox_msg">
              <div class="sidebar">
                  <div class="sidebar_top">
                      <div class="logo">
                          <img src="../assets/img/logo.png" id="sidebar_logo" alt="logo">
                      </div>
                      <div class="sidebar_img">
                          <img src="../assets/img/oval.png" id="sidebar_avatar" alt="Girl in a jacket">
                      </div>
                  </div>
                  <div class="sidebar_nav">
                      <div class="sidebar_nav_el_first" v-on:click="selectedTab = 'active'">
                          <div class="navbar_icon">
                              <img src="../assets/img/chat.png" id="sidebar_nav_chat" alt="chat">
                          </div>
                          <h5 id="active">Active</h5>
                          <div class="sidebar_notif_active">
                              <p>{{countActive}}</p>
                          </div>
                      </div>
                      <div class="sidebar_nav_el" v-on:click="selectedTab = 'done'">
                          <div class="navbar_icon">
                              <img src="../assets/img/finished-chat.png" id="sidebar_nav_closed" alt="chat">
                          </div>
                          <h5 id="closed">Closed</h5>
                          <div class="sidebar_notif_closed">
                              <p>{{countClosed}}</p>
                          </div>
                      </div>
                  </div>
              </div>
              <div class="inbox_people">
                  <div class="headind_srch">
                      <div class="recent_heading">
                          <h4 id="active_convo">{{selectedTab == 'active' ? 'Active Conversations' : 'Closed conversations'}}</h4>
                      </div>
                  </div>
                  <div class="inbox_chat">
                      <div class="chat_list" v-for="chat in chats" :key="chat.socketId" @click="selectedChatSocketId = chat.socketId">
                          <div class="chat_people">
                              <div class="chat_ib">
                                  <div class="chat_ib_top">
                                      <p id="chat_ib_top_date">{{chat.date}}</p>
                                      <button type="button" class="done" v-on:click.stop="markAsDone(chat)">Mark as done ✓</button>
                                  </div>
                                  <div class="chat_ib_mid">
                                      <p id="chat_ib_mid_msg">{{chat.messages[0].msg}}</p>
                                  </div>
                                  <div class="chat_ib_bot">
                                      <button type="button" class="newmsg" v-on:click.stop="deleteChat(chat)">Delete</button>
                                  </div>
                              </div>
                          </div>
                      </div>
                  </div>
              </div>
              <div class="mesgs">
                  <div id="msg_history">
                      <div v-if="selectedChatSocketId && chats[selectedChatSocketId]">
                        <div :class="(message.from == 'user') ? 'outgoing_msg' : 'incoming_msg'"
                            v-for="(message,i) in chats[selectedChatSocketId].messages" :key="i">

                            <div :class="(message.from =='user') ? 'sent_msg' : 'received_msg'">
                                <div :class="(message.from == 'user') ? 'sent_with_msg' : 'received_withd_msg'">
                                    <p>{{message.msg}}</p>
                                    <span class="time_date">{{message.formatedTime}}</span>
                                </div>
                            </div>
                        </div>
                      </div>
                  </div>
                  <div class="type_msg">
                      <div class="write" v-if="chats[selectedChatSocketId] && chats[selectedChatSocketId].status == 'active'">
                          <div class="input_msg_write">
                              <input type="text" class="write_msg" placeholder="Type a message" v-model="adminmsg"
                                  @keyup.enter.prevent="sendadmin" />

                                  <div class="input_msg_write_button" @click="sendadmin">
                                    <img src="../assets/img/send@2x.svg" alt="senddone_button">
                                </div>
                            </div>
                      </div>
                      <div class="marked_as_done" v-else>
                          <div id="admin_marked">
                              <h3 id="admin_marked_text"> The conversation was marked as closed.
                              </h3>
                          </div>
                      </div>
                  </div>
              </div>
          </div>
      </div>
  </div>
</template>

<script>
import io from 'socket.io-client';
import moment from 'moment';
import axios from 'axios';

const mp3 = require('../assets/sound/notif.ogg');

export default {
    name: 'newchatadmin',
    data()
    {
        return {
            msg: '',
            socket: null,
            adminChats: [],
            selectedTab: 'active',
            selectedChatSocketId: null,
            adminmsg: '',
            countActive: 0,
            countClosed: 0,
            soundInterval: null,
        };
    },
    async created()
    {
        const me = this;
        try
        {
            me.sound = new Audio(mp3);

            me.socket = io('https://sinteza-chat.herokuapp.com');
            me.socket.emit('admin', '');

            me.reloadChats();

            me.socket.on('received', (data) =>
            {
                if (me.soundInterval == null)
                {
                    me.soundInterval = setInterval(() =>
                    {
                        me.sound.play();
                    }, 1000);
                }

                if (me.chats[data.socketId] === undefined)
                {
                    me.adminChats.push({
                        socketId: data.socketId,
                        messages: [],
                        status: data.status,
                    });
                    // eslint-disable-next-line no-unused-expressions
                    console.log(me.chats);
                }

                me.chats[data.socketId].messages.push(data);

                me.$nextTick(() =>
                {
                    me.updateScroll();
                });
            });
        }
        catch (error)
        {
            console.error(error);
        }
    },
    methods: {
        stopSound()
        {
            const me = this;

            if (me.soundInterval !== null)
            {
                clearInterval(me.soundInterval);
                me.soundInterval = null;
            }
        },
        async reloadChats()
        {
            const me = this;
            try
            {
                const response = await axios.get('https://sinteza-chat.herokuapp.com/fetchadminchats');

                if (response.data && response.data.length)
                {
                    me.adminChats = response.data;
                }
                else
                {
                    me.adminChats = [];
                }
            }
            catch (error)
            {
                console.error(error);
            }
        },
        async deleteChat(chat)
        {
            const me = this;
            try
            {
                const response = await axios.post('https://sinteza-chat.herokuapp.com/deletechat', {
                    socketId: chat.socketId,
                });

                if (response.data === 'ok')
                {
                    me.reloadChats();
                }
            }
            catch (error)
            {
                console.error(error);
            }
        },
        async markAsDone(chat)
        {
            const me = this;
            try
            {
                const response = await axios.post('https://sinteza-chat.herokuapp.com/markAsDone', {
                    socketId: chat.socketId,
                });

                if (response.data === 'ok')
                {
                    me.reloadChats();
                }
            }
            catch (error)
            {
                console.error(error);
            }
        },
        updateScroll()
        {
            const element = document.getElementById('msg_history');
            element.scrollTop = element.scrollHeight;
        },
        sendadmin()
        {
            const me = this;

            const message = {
                msg: me.adminmsg,
                from: 'admin',
                formatedTime: moment().format('HH:mm:ss'),
                socketId: me.selectedChatSocketId,
            };

            me.socket.emit('adminmessage', message);

            me.chats[me.selectedChatSocketId].messages.push(message);

            me.adminmsg = '';
            me.$nextTick(() =>
            {
                me.updateScroll();
            });
        },

    },
    computed:
    {
        chats()
        {
            const me = this;
            const chats = {};

            me.countActive = 0;
            me.countClosed = 0;

            for (const chat of me.adminChats)
            {
                if (chat.status === 'active')
                {
                    me.countActive += 1;
                }
                else
                {
                    me.countClosed += 1;
                }

                if (me.selectedTab === chat.status)
                {
                    chats[chat.socketId] = chat;
                }
            }

            return chats;
        },
    },

};
</script>
